## libbitarray 2.0

=== Makefile ===
CC ?= gcc

PLATFORM := $(shell uname)
COMPILER := $(shell ($(CC) -v 2>&1) | tr A-Z a-z )

ifdef DEBUG
	OPT = -O0 -DDEBUG=1 --debug -g -ggdb
else
	ifneq (,$(findstring gcc,$(COMPILER)))
		OPT = -O4
		TGTFLAGS = -fwhole-program
	else
		OPT = -O3
	endif
endif

CFLAGS = -Wall -Wextra -Wc++-compat -I. $(OPT)
OBJFLAGS = -fPIC

all: libbitarr.a dev examples

bit_array.o: bit_array.c bit_array.h bit_macros.h

libbitarr.a: bit_array.o
	ar -csru libbitarr.a bit_array.o

%.o: %.c %.h
	$(CC) $(CFLAGS) $(OBJFLAGS) -c $< -o $@

dev: libbitarr.a bit_macros.h
	cd dev && $(MAKE) 

examples: libbitarr.a
	cd examples && $(MAKE)

test: libbitarr.a
	cd dev && $(MAKE) test
	cd examples && $(MAKE) test

clean:
	rm -rf libbitarr.a *.o *.dSYM *.greg
	cd dev && $(MAKE) clean
	cd examples && $(MAKE) clean

# Comment this line out to keep .o files
.INTERMEDIATE: $(OBJS)
.PHONY: all clean test examples dev

=== dev/Makefile ===
ifndef CC
	CC = gcc
endif

ifdef DEBUG
	OPT = -DDEBUG=1 --debug -g
else
	OPT = -O3
endif

CFLAGS = -Wall -Wextra -Wc++-compat

all: bit_array_test bitlock_test bitlock_try_test bit_array_generate

bit_array_test: bit_array_test.c ../bar.h ../libbitarr.a
	$(CC) $(OPT) $(CFLAGS) -I.. -L.. -o bit_array_test bit_array_test.c -lbitarr

bitlock_test: bitlock_test.c ../bit_macros.h
	$(CC) $(OPT) $(CFLAGS) -I.. -o bitlock_test bitlock_test.c -lpthread

bitlock_try_test: bitlock_try_test.c ../bit_macros.h
	$(CC) $(OPT) $(CFLAGS) -I.. -o bitlock_try_test bitlock_try_test.c -lpthread

bit_array_generate:
	$(CC) $(OPT) $(CFLAGS) -o bit_array_generate bit_array_generate.c


../libbitarr.a:
	cd .. && make

test: bit_array_test bitlock_test
	./bit_array_test && ./bitlock_test

clean:
	rm -rf  bit_array_test bitlock_test bit_array_generate
	rm -rf bitarr_example.dump *.o *.dSYM *.greg

.PHONY: all clean test

=== examples/Makefile ===
ifndef CC
	CC = gcc
endif

CFLAGS = -Wall -Wextra -I.. -L..

all: example_cpp example_c

example_cpp: example.cpp ../libbitarr.a
	$(CXX) $(CFLAGS) -o example_cpp example.cpp -lbitarr

example_c: example.c ../libbitarr.a
	$(CC) $(CFLAGS) -Wc++-compat -o example_c example.c -lbitarr

test: example_c example_cpp
	./example_c
	./example_cpp

clean:
	rm -rf example_cpp example_c *.o *.dSYM *.greg

.PHONY: all clean test

=== debian/changelog ===
libbitarray (2.0-2) unstable; urgency=medium

  * Fix autopkgtest
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Mon, 28 Nov 2022 15:20:29 +0100

libbitarray (2.0-1) unstable; urgency=medium

  * Initial release (Closes: #1021377)

 -- Andreas Tille <tille@debian.org>  Fri, 07 Oct 2022 08:37:28 +0200

=== debian/control ===
Source: libbitarray
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/libbitarray
Vcs-Git: https://salsa.debian.org/med-team/libbitarray.git
Homepage: https://github.com/noporpoise/BitArray
Rules-Requires-Root: no

Package: libbitarray-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: library for bit arrays
 Bit arrays are arrays of bits (values zero or one). This is a convenient
 and efficient implementation for C/C++. Arrays can be enlarged or shrunk
 as needed.
 .
 Bit arrays are initialised to zero when created or extended. All
 operations have their bounds checked - an "Out of bounds" error is
 printed if you try to access a bit with index >= length. Arrays of
 length 0 are permitted. Indices must be >= 0.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/noporpoise/BitArray/tags (?:.*?/)?v?@ANY_VERSION@\.tar\.gz
